﻿#if USE_UNI_LUA
using LuaAPI = UniLua.Lua;
using RealStatePtr = UniLua.ILuaState;
using LuaCSFunction = UniLua.CSharpFunctionDelegate;
#else
using LuaAPI = XLua.LuaDLL.Lua;
using RealStatePtr = System.IntPtr;
using LuaCSFunction = XLua.LuaDLL.lua_CSFunction;
#endif

using XLua;
using System.Collections.Generic;


namespace XLua.CSObjectWrap
{
    using Utils = XLua.Utils;
    public class UnityEngineRenderingColorUtilsWrap 
    {
        public static void __Register(RealStatePtr L)
        {
			ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
			System.Type type = typeof(UnityEngine.Rendering.ColorUtils);
			Utils.BeginObjectRegister(type, L, translator, 0, 0, 0, 0);
			
			
			
			
			
			
			Utils.EndObjectRegister(type, L, translator, null, null,
			    null, null, null);

		    Utils.BeginClassRegister(type, L, __CreateInstance, 15, 0, 0);
			Utils.RegisterFunc(L, Utils.CLS_IDX, "StandardIlluminantY", _m_StandardIlluminantY_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "CIExyToLMS", _m_CIExyToLMS_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ColorBalanceToLMSCoeffs", _m_ColorBalanceToLMSCoeffs_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "PrepareShadowsMidtonesHighlights", _m_PrepareShadowsMidtonesHighlights_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "PrepareLiftGammaGain", _m_PrepareLiftGammaGain_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "PrepareSplitToning", _m_PrepareSplitToning_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "Luminance", _m_Luminance_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ComputeEV100", _m_ComputeEV100_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ConvertEV100ToExposure", _m_ConvertEV100ToExposure_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ConvertExposureToEV100", _m_ConvertExposureToEV100_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ComputeEV100FromAvgLuminance", _m_ComputeEV100FromAvgLuminance_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ComputeISO", _m_ComputeISO_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ToHex", _m_ToHex_xlua_st_);
            Utils.RegisterFunc(L, Utils.CLS_IDX, "ToRGBA", _m_ToRGBA_xlua_st_);
            
			
            
			
			
			
			Utils.EndClassRegister(type, L, translator);
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int __CreateInstance(RealStatePtr L)
        {
            return LuaAPI.luaL_error(L, "UnityEngine.Rendering.ColorUtils does not have a constructor!");
        }
        
		
        
		
        
        
        
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_StandardIlluminantY_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _x = (float)LuaAPI.lua_tonumber(L, 1);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.StandardIlluminantY( _x );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_CIExyToLMS_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    float _x = (float)LuaAPI.lua_tonumber(L, 1);
                    float _y = (float)LuaAPI.lua_tonumber(L, 2);
                    
                        UnityEngine.Vector3 gen_ret = UnityEngine.Rendering.ColorUtils.CIExyToLMS( _x, _y );
                        translator.PushUnityEngineVector3(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ColorBalanceToLMSCoeffs_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    float _temperature = (float)LuaAPI.lua_tonumber(L, 1);
                    float _tint = (float)LuaAPI.lua_tonumber(L, 2);
                    
                        UnityEngine.Vector3 gen_ret = UnityEngine.Rendering.ColorUtils.ColorBalanceToLMSCoeffs( _temperature, _tint );
                        translator.PushUnityEngineVector3(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_PrepareShadowsMidtonesHighlights_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    UnityEngine.Vector4 _inShadows;translator.Get(L, 1, out _inShadows);
                    UnityEngine.Vector4 _inMidtones;translator.Get(L, 2, out _inMidtones);
                    UnityEngine.Vector4 _inHighlights;translator.Get(L, 3, out _inHighlights);
                    
                        System.ValueTuple<UnityEngine.Vector4, UnityEngine.Vector4, UnityEngine.Vector4> gen_ret = UnityEngine.Rendering.ColorUtils.PrepareShadowsMidtonesHighlights( ref _inShadows, ref _inMidtones, ref _inHighlights );
                        translator.Push(L, gen_ret);
                    translator.PushUnityEngineVector4(L, _inShadows);
                        translator.UpdateUnityEngineVector4(L, 1, _inShadows);
                        
                    translator.PushUnityEngineVector4(L, _inMidtones);
                        translator.UpdateUnityEngineVector4(L, 2, _inMidtones);
                        
                    translator.PushUnityEngineVector4(L, _inHighlights);
                        translator.UpdateUnityEngineVector4(L, 3, _inHighlights);
                        
                    
                    
                    
                    return 4;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_PrepareLiftGammaGain_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    UnityEngine.Vector4 _inLift;translator.Get(L, 1, out _inLift);
                    UnityEngine.Vector4 _inGamma;translator.Get(L, 2, out _inGamma);
                    UnityEngine.Vector4 _inGain;translator.Get(L, 3, out _inGain);
                    
                        System.ValueTuple<UnityEngine.Vector4, UnityEngine.Vector4, UnityEngine.Vector4> gen_ret = UnityEngine.Rendering.ColorUtils.PrepareLiftGammaGain( ref _inLift, ref _inGamma, ref _inGain );
                        translator.Push(L, gen_ret);
                    translator.PushUnityEngineVector4(L, _inLift);
                        translator.UpdateUnityEngineVector4(L, 1, _inLift);
                        
                    translator.PushUnityEngineVector4(L, _inGamma);
                        translator.UpdateUnityEngineVector4(L, 2, _inGamma);
                        
                    translator.PushUnityEngineVector4(L, _inGain);
                        translator.UpdateUnityEngineVector4(L, 3, _inGain);
                        
                    
                    
                    
                    return 4;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_PrepareSplitToning_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    UnityEngine.Vector4 _inShadows;translator.Get(L, 1, out _inShadows);
                    UnityEngine.Vector4 _inHighlights;translator.Get(L, 2, out _inHighlights);
                    float _balance = (float)LuaAPI.lua_tonumber(L, 3);
                    
                        System.ValueTuple<UnityEngine.Vector4, UnityEngine.Vector4> gen_ret = UnityEngine.Rendering.ColorUtils.PrepareSplitToning( ref _inShadows, ref _inHighlights, _balance );
                        translator.Push(L, gen_ret);
                    translator.PushUnityEngineVector4(L, _inShadows);
                        translator.UpdateUnityEngineVector4(L, 1, _inShadows);
                        
                    translator.PushUnityEngineVector4(L, _inHighlights);
                        translator.UpdateUnityEngineVector4(L, 2, _inHighlights);
                        
                    
                    
                    
                    return 3;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Luminance_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    UnityEngine.Color _color;translator.Get(L, 1, out _color);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.Luminance( ref _color );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    translator.PushUnityEngineColor(L, _color);
                        translator.UpdateUnityEngineColor(L, 1, _color);
                        
                    
                    
                    
                    return 2;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ComputeEV100_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _aperture = (float)LuaAPI.lua_tonumber(L, 1);
                    float _shutterSpeed = (float)LuaAPI.lua_tonumber(L, 2);
                    float _ISO = (float)LuaAPI.lua_tonumber(L, 3);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.ComputeEV100( _aperture, _shutterSpeed, _ISO );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ConvertEV100ToExposure_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _EV100 = (float)LuaAPI.lua_tonumber(L, 1);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.ConvertEV100ToExposure( _EV100 );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ConvertExposureToEV100_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _exposure = (float)LuaAPI.lua_tonumber(L, 1);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.ConvertExposureToEV100( _exposure );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ComputeEV100FromAvgLuminance_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _avgLuminance = (float)LuaAPI.lua_tonumber(L, 1);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.ComputeEV100FromAvgLuminance( _avgLuminance );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ComputeISO_xlua_st_(RealStatePtr L)
        {
		    try {
            
            
            
                
                {
                    float _aperture = (float)LuaAPI.lua_tonumber(L, 1);
                    float _shutterSpeed = (float)LuaAPI.lua_tonumber(L, 2);
                    float _targetEV100 = (float)LuaAPI.lua_tonumber(L, 3);
                    
                        float gen_ret = UnityEngine.Rendering.ColorUtils.ComputeISO( _aperture, _shutterSpeed, _targetEV100 );
                        LuaAPI.lua_pushnumber(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ToHex_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    UnityEngine.Color _c;translator.Get(L, 1, out _c);
                    
                        uint gen_ret = UnityEngine.Rendering.ColorUtils.ToHex( _c );
                        LuaAPI.xlua_pushuint(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ToRGBA_xlua_st_(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
            
                
                {
                    uint _hex = LuaAPI.xlua_touint(L, 1);
                    
                        UnityEngine.Color gen_ret = UnityEngine.Rendering.ColorUtils.ToRGBA( _hex );
                        translator.PushUnityEngineColor(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        
        
        
        
        
		
		
		
		
    }
}
