﻿#if USE_UNI_LUA
using LuaAPI = UniLua.Lua;
using RealStatePtr = UniLua.ILuaState;
using LuaCSFunction = UniLua.CSharpFunctionDelegate;
#else
using LuaAPI = XLua.LuaDLL.Lua;
using RealStatePtr = System.IntPtr;
using LuaCSFunction = XLua.LuaDLL.lua_CSFunction;
#endif

using XLua;
using System.Collections.Generic;


namespace XLua.CSObjectWrap
{
    using Utils = XLua.Utils;
    public class UnityEngineRenderingUniversalInternalPostProcessPassWrap 
    {
        public static void __Register(RealStatePtr L)
        {
			ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
			System.Type type = typeof(UnityEngine.Rendering.Universal.Internal.PostProcessPass);
			Utils.BeginObjectRegister(type, L, translator, 0, 7, 0, 0);
			
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Cleanup", _m_Cleanup);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Setup", _m_Setup);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "SetupFinalPass", _m_SetupFinalPass);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Configure", _m_Configure);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "ResetHistory", _m_ResetHistory);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "CanRunOnTile", _m_CanRunOnTile);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Execute", _m_Execute);
			
			
			
			
			
			Utils.EndObjectRegister(type, L, translator, null, null,
			    null, null, null);

		    Utils.BeginClassRegister(type, L, __CreateInstance, 1, 0, 0);
			
			
            
			
			
			
			Utils.EndClassRegister(type, L, translator);
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int __CreateInstance(RealStatePtr L)
        {
            
			try {
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
				if(LuaAPI.lua_gettop(L) == 4 && translator.Assignable<UnityEngine.Rendering.Universal.RenderPassEvent>(L, 2) && translator.Assignable<UnityEngine.Rendering.Universal.PostProcessData>(L, 3) && translator.Assignable<UnityEngine.Material>(L, 4))
				{
					UnityEngine.Rendering.Universal.RenderPassEvent _evt;translator.Get(L, 2, out _evt);
					UnityEngine.Rendering.Universal.PostProcessData _data = (UnityEngine.Rendering.Universal.PostProcessData)translator.GetObject(L, 3, typeof(UnityEngine.Rendering.Universal.PostProcessData));
					UnityEngine.Material _blitMaterial = (UnityEngine.Material)translator.GetObject(L, 4, typeof(UnityEngine.Material));
					
					UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_ret = new UnityEngine.Rendering.Universal.Internal.PostProcessPass(_evt, _data, _blitMaterial);
					translator.Push(L, gen_ret);
                    
					return 1;
				}
				if(LuaAPI.lua_gettop(L) == 3 && translator.Assignable<UnityEngine.Rendering.Universal.RenderPassEvent>(L, 2) && translator.Assignable<UnityEngine.Rendering.Universal.PostProcessData>(L, 3))
				{
					UnityEngine.Rendering.Universal.RenderPassEvent _evt;translator.Get(L, 2, out _evt);
					UnityEngine.Rendering.Universal.PostProcessData _data = (UnityEngine.Rendering.Universal.PostProcessData)translator.GetObject(L, 3, typeof(UnityEngine.Rendering.Universal.PostProcessData));
					
					UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_ret = new UnityEngine.Rendering.Universal.Internal.PostProcessPass(_evt, _data);
					translator.Push(L, gen_ret);
                    
					return 1;
				}
				
			}
			catch(System.Exception gen_e) {
				return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
			}
            return LuaAPI.luaL_error(L, "invalid arguments to UnityEngine.Rendering.Universal.Internal.PostProcessPass constructor!");
            
        }
        
		
        
		
        
        
        
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Cleanup(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    
                    gen_to_be_invoked.Cleanup(  );
                    
                    
                    
                    return 0;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Setup(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.RenderTextureDescriptor _baseDescriptor;translator.Get(L, 2, out _baseDescriptor);
                    UnityEngine.Rendering.Universal.RenderTargetHandle _source;translator.Get(L, 3, out _source);
                    UnityEngine.Rendering.Universal.RenderTargetHandle _destination;translator.Get(L, 4, out _destination);
                    UnityEngine.Rendering.Universal.RenderTargetHandle _depth;translator.Get(L, 5, out _depth);
                    UnityEngine.Rendering.Universal.RenderTargetHandle _internalLut;translator.Get(L, 6, out _internalLut);
                    bool _hasFinalPass = LuaAPI.lua_toboolean(L, 7);
                    bool _enableSRGBConversion = LuaAPI.lua_toboolean(L, 8);
                    
                    gen_to_be_invoked.Setup( ref _baseDescriptor, ref _source, ref _destination, ref _depth, ref _internalLut, _hasFinalPass, _enableSRGBConversion );
                    translator.Push(L, _baseDescriptor);
                        translator.Update(L, 2, _baseDescriptor);
                        
                    translator.Push(L, _source);
                        translator.Update(L, 3, _source);
                        
                    translator.Push(L, _destination);
                        translator.Update(L, 4, _destination);
                        
                    translator.Push(L, _depth);
                        translator.Update(L, 5, _depth);
                        
                    translator.Push(L, _internalLut);
                        translator.Update(L, 6, _internalLut);
                        
                    
                    
                    
                    return 5;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_SetupFinalPass(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.Universal.RenderTargetHandle _source;translator.Get(L, 2, out _source);
                    
                    gen_to_be_invoked.SetupFinalPass( ref _source );
                    translator.Push(L, _source);
                        translator.Update(L, 2, _source);
                        
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Configure(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.CommandBuffer _cmd = (UnityEngine.Rendering.CommandBuffer)translator.GetObject(L, 2, typeof(UnityEngine.Rendering.CommandBuffer));
                    UnityEngine.RenderTextureDescriptor _cameraTextureDescriptor;translator.Get(L, 3, out _cameraTextureDescriptor);
                    
                    gen_to_be_invoked.Configure( _cmd, _cameraTextureDescriptor );
                    
                    
                    
                    return 0;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_ResetHistory(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    
                    gen_to_be_invoked.ResetHistory(  );
                    
                    
                    
                    return 0;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_CanRunOnTile(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    
                        bool gen_ret = gen_to_be_invoked.CanRunOnTile(  );
                        LuaAPI.lua_pushboolean(L, gen_ret);
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Execute(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.PostProcessPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.PostProcessPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.ScriptableRenderContext _context;translator.Get(L, 2, out _context);
                    UnityEngine.Rendering.Universal.RenderingData _renderingData;translator.Get(L, 3, out _renderingData);
                    
                    gen_to_be_invoked.Execute( _context, ref _renderingData );
                    translator.Push(L, _renderingData);
                        translator.Update(L, 3, _renderingData);
                        
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        
        
        
        
        
		
		
		
		
    }
}
